/**
 * Adapted from ReactCSSTransitionGroup.js by Facebook
 *
 * @providesModule ReactReactCSSTransitionReplace
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ReactCSSTransitionReplaceChild = require('./ReactCSSTransitionReplaceChild');

var _ReactCSSTransitionReplaceChild2 = _interopRequireDefault(_ReactCSSTransitionReplaceChild);

var ReactCSSTransitionReplaceChild = _reactAddons2['default'].createFactory(_ReactCSSTransitionReplaceChild2['default']);
var ReactTransitionGroup = _reactAddons2['default'].addons.TransitionGroup;

var ReactCSSTransitionReplace = (function (_React$Component) {
  _inherits(ReactCSSTransitionReplace, _React$Component);

  function ReactCSSTransitionReplace(props) {
    _classCallCheck(this, ReactCSSTransitionReplace);

    _get(Object.getPrototypeOf(ReactCSSTransitionReplace.prototype), 'constructor', this).call(this, props);

    this._childEntered = this._childEntered.bind(this);
    this._childLeft = this._childLeft.bind(this);
    this._wrapChild = this._wrapChild.bind(this);

    this.state = {
      currentChild: _reactAddons2['default'].Children.only(props.children),
      nextChild: null,
      height: 'auto'
    };
  }

  _createClass(ReactCSSTransitionReplace, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this = this;

      var nextChild = nextProps.children ? _reactAddons2['default'].Children.only(nextProps.children) : null;
      var currentChild = this.state.currentChild;

      if (currentChild && nextChild && nextChild.key === currentChild.key) {
        // Nothing changed, but we are re-rendering so update the currentChild.
        return this.setState({
          currentChild: nextChild
        });
      }

      var transitionHeight = nextProps.transitionHeight;
      var currentHeight = transitionHeight ? _reactAddons2['default'].findDOMNode(this.refs.container).offsetHeight : 'auto';

      // The child was removed, so animate out.
      if (!nextChild) {
        return this.setState({
          height: currentHeight,
          currentChild: null
        }, function () {
          return transitionHeight && _this.setState({ height: 0 });
        });
      }

      // The child was replaced or added, setting a nextChild will eventually animate it in.
      this.setState({
        height: currentHeight,
        currentChild: null,
        nextChild: nextChild
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var nextChild = _reactAddons2['default'].findDOMNode(this.refs.nextChild);

      // If there is a next child we'll be animating it in soon, so change to its height.
      if (nextChild && nextChild.offsetHeight !== this.state.height) {
        this.setState({
          height: nextChild.offsetHeight
        });
      }
    }
  }, {
    key: '_childLeft',
    value: function _childLeft() {
      // Swap the children after the current child left.
      this.setState({
        currentChild: this.state.nextChild,
        nextChild: null
      });
    }
  }, {
    key: '_childEntered',
    value: function _childEntered() {
      // The height animation would have finished, so switch back to auto.
      if (this.props.transitionHeight) {
        this.setState({
          height: 'auto'
        });
      }
    }
  }, {
    key: '_wrapChild',
    value: function _wrapChild(child) {
      // We need to provide this childFactory so that
      // ReactCSSTransitionReplaceChild can receive updates to name,
      // enter, and leave while it is leaving.
      return ReactCSSTransitionReplaceChild({
        name: this.props.transitionName,
        appear: this.props.transitionAppear,
        enter: this.props.transitionEnter,
        leave: this.props.transitionLeave,
        onEntered: this._childEntered,
        onLeft: this._childLeft
      }, child);
    }
  }, {
    key: 'render',
    value: function render() {
      var style = this.props.style;
      var nextChildShadow = undefined;
      var heightClassName = undefined;

      if (this.props.transitionHeight) {
        if (this.state.nextChild) {
          nextChildShadow = _reactAddons2['default'].createElement(
            'div',
            { ref: 'nextChild', style: { position: 'absolute', visibility: 'hidden' } },
            this.state.nextChild
          );
        }

        heightClassName = this.props.transitionName + '-height';

        style = {
          overflow: this.state.height !== 'auto' ? 'hidden' : 'visible',
          height: this.state.height,
          display: 'block'
        };
      }

      return _reactAddons2['default'].createElement(
        'span',
        null,
        nextChildShadow,
        _reactAddons2['default'].createElement(
          ReactTransitionGroup,
          _extends({ ref: 'container' }, this.props, { childFactory: this._wrapChild, style: style,
            className: (0, _classnames2['default'])(this.props.className, heightClassName) }),
          this.state.currentChild
        )
      );
    }
  }]);

  return ReactCSSTransitionReplace;
})(_reactAddons2['default'].Component);

ReactCSSTransitionReplace.propTypes = {
  transitionName: _reactAddons2['default'].PropTypes.string.isRequired,
  transitionAppear: _reactAddons2['default'].PropTypes.bool,
  transitionEnter: _reactAddons2['default'].PropTypes.bool,
  transitionLeave: _reactAddons2['default'].PropTypes.bool,
  transitionHeight: _reactAddons2['default'].PropTypes.bool
};

ReactCSSTransitionReplace.defaultProps = {
  transitionAppear: false,
  transitionEnter: true,
  transitionLeave: true,
  transitionHeight: true
};

exports['default'] = ReactCSSTransitionReplace;
module.exports = exports['default'];