/**
 * Adapted from ReactCSSTransitionGroupChild.js by Facebook
 *
 * @providesModule ReactCSSTransitionReplaceChild
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactLibReactTransitionEvents = require('react/lib/ReactTransitionEvents');

var _reactLibReactTransitionEvents2 = _interopRequireDefault(_reactLibReactTransitionEvents);

var _reactLibCSSCore = require('react/lib/CSSCore');

var _reactLibCSSCore2 = _interopRequireDefault(_reactLibCSSCore);

// We don't remove the element from the DOM until we receive an animationend or
// transitionend event. If the user screws up and forgets to add an animation
// their node will be stuck in the DOM forever, so we detect if an animation
// does not start and if it doesn't, we just call the end listener immediately.
var TICK = 17;
var NO_EVENT_TIMEOUT = 5000;

var noEventListener = null;

if ('production' !== process.env.NODE_ENV) {
  noEventListener = function () {
    process.env.NODE_ENV !== 'production' ? console.warn('transition(): tried to perform an animation without ' + 'an animationend or transitionend event after timeout (' + NO_EVENT_TIMEOUT + 'ms). You should either disable this ' + 'transition in JS or add a CSS animation/transition.') : null;
  };
}

var ReactCSSTransitionReplaceChild = (function (_React$Component) {
  _inherits(ReactCSSTransitionReplaceChild, _React$Component);

  function ReactCSSTransitionReplaceChild(props) {
    _classCallCheck(this, ReactCSSTransitionReplaceChild);

    _get(Object.getPrototypeOf(ReactCSSTransitionReplaceChild.prototype), 'constructor', this).call(this, props);
    this.flushClassNameQueue = this.flushClassNameQueue.bind(this);
  }

  _createClass(ReactCSSTransitionReplaceChild, [{
    key: 'transition',
    value: function transition(animationType, finishCallback) {
      var node = _react2['default'].findDOMNode(this);
      var className = this.props.name + '-' + animationType;
      var activeClassName = className + '-active';
      var noEventTimeout = null;

      var endListener = function endListener(e) {
        if (e && e.target !== node) {
          return;
        }
        if ('production' !== process.env.NODE_ENV) {
          clearTimeout(noEventTimeout);
        }

        _reactLibCSSCore2['default'].removeClass(node, className);
        _reactLibCSSCore2['default'].removeClass(node, activeClassName);

        _reactLibReactTransitionEvents2['default'].removeEndEventListener(node, endListener);

        // Usually this optional callback is used for informing an owner of
        // a leave animation and telling it to remove the child.
        if (finishCallback) {
          finishCallback();
        }
      };

      _reactLibReactTransitionEvents2['default'].addEndEventListener(node, endListener);

      _reactLibCSSCore2['default'].addClass(node, className);

      // Need to do this to actually trigger a transition.
      this.queueClass(activeClassName);

      if ('production' !== process.env.NODE_ENV) {
        noEventTimeout = setTimeout(noEventListener, NO_EVENT_TIMEOUT);
      }
    }
  }, {
    key: 'queueClass',
    value: function queueClass(className) {
      this.classNameQueue.push(className);

      if (!this.timeout) {
        this.timeout = setTimeout(this.flushClassNameQueue, TICK);
      }
    }
  }, {
    key: 'flushClassNameQueue',
    value: function flushClassNameQueue() {
      var _this = this;

      if (this._mounted) {
        this.classNameQueue.forEach(function (className) {
          return _reactLibCSSCore2['default'].addClass(_react2['default'].findDOMNode(_this), className);
        });
      }
      this.classNameQueue.length = 0;
      this.timeout = null;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.classNameQueue = [];
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._mounted = true;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      delete this._mounted;
      if (this.timeout) {
        clearTimeout(this.timeout);
      }
    }
  }, {
    key: 'componentWillAppear',
    value: function componentWillAppear(done) {
      this.props.appear ? this.transition('appear', done) : done();
    }
  }, {
    key: 'componentWillEnter',
    value: function componentWillEnter(done) {
      this.props.enter ? this.transition('enter', done) : done();
    }
  }, {
    key: 'componentWillLeave',
    value: function componentWillLeave(done) {
      this.props.leave ? this.transition('leave', done) : done();
    }
  }, {
    key: 'componentDidEnter',
    value: function componentDidEnter() {
      this.props.onEntered();
    }
  }, {
    key: 'componentDidLeave',
    value: function componentDidLeave() {
      this.props.onLeft();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].Children.only(this.props.children);
    }
  }]);

  return ReactCSSTransitionReplaceChild;
})(_react2['default'].Component);

exports['default'] = ReactCSSTransitionReplaceChild;
module.exports = exports['default'];